######import dietary information#####
fiveFamAllDiet_CATs<-read.csv("./data/simmap_cats/allFiveFams_646sp_4cats.csv")
rownames(fiveFamAllDiet_CATs)<-fiveFamAllDiet_CATs$species

#match with tree
fiveFamALLdietsorted<-treedata(fiveFamTreeALL,fiveFamAllDiet_CATs,sort=TRUE,
                               warnings=TRUE)
ladderize(fiveFamALLdietsorted$phy)->fiveFam_dietTree
data.frame(fiveFamALLdietsorted$data)->fiveFam_dietCats

#set up color vectors
fiveFamColr<-rep("gray70", length(fiveFam_dietCats[,1]))
fiveFamColr[fiveFam_dietCats[,2]==2]<-"#FF9900" 
fiveFamColr[fiveFam_dietCats[,2]==3]<-"#00BA57"
fiveFamColr[fiveFam_dietCats[,2]==4]<-"#5D3BE9"
names(fiveFamColr)<-fiveFam_dietCats[,1]
fiveFamColr<-fiveFamColr[fiveFam_dietTree$tip.label]
fourCols<-c("gray80","#ff9900","#00BA57","#5D3BE9")
names(fourCols)<-c("1","2","3","4")
fourcolors=setNames(c("gray80","#ff9900","#00BA57","#5D3BE9"),c(1,2,3,4))

######all five fams simmap#####
#use fitDiscrete to select best evolutionary model
#fiveFamFitER<-fitDiscrete(fiveFam_dietTree,fiveFam_dietCats$diet,model="ER")
#fiveFamFitSYM<-fitDiscrete(fiveFam_dietTree,fiveFam_dietCats$diet,model="SYM")
#fiveFamFitARD<-fitDiscrete(fiveFam_dietTree,fiveFam_dietCats$diet,model="ARD")
#fiveFamDisaicc<-c(fiveFamFitER$opt$aicc,
#                  fiveFamFitSYM$opt$aicc,
#                  fiveFamFitARD$opt$aicc)
#names(fiveFamDisaicc)<-c("ER","SYM","ARD")
#fiveFamDisaicc-min(fiveFamDisaicc) #ARD is best but has issues. Will use SYM

#use fitMk and then parallelize
# to save time, here is the Q-matrix that results from fitMk
fiveFamMk_SYM_Q<-rbind(c(-0.006500855,0.005249942,0.001250913,0.0000000),
                       c(0.005249942,-0.025999398,0.020749456,0.0000000),
                       c(0.001250913,0.020749456,-0.136974754,0.1149744),
                       c(0.000000000,0.000000000,0.114974385,-0.1149744))
rownames(fiveFamMk_SYM_Q)=1:4
colnames(fiveFamMk_SYM_Q)=1:4
#or to run it yourself:
#fiveFamMk_SYM<-fitMk(fiveFam_dietTree,fiveFam_dietCats$diet,
#model="SYM",pi=c(1,0,0,0))
#fiveFamMk_SYM_Q<-matrix(NA,length(fiveFamMk_SYM$states),
#                        length(fiveFamMk_SYM$states))
#fiveFamMk_SYM_Q[]<-c(0,fiveFamMk_SYM$rates)[fiveFamMk_SYM$index.matrix+1]
#diag(fiveFamMk_SYM_Q)<-0
#diag(fiveFamMk_SYM_Q)<--rowSums(fiveFamMk_SYM_Q)
#colnames(fiveFamMk_SYM_Q)<-rownames(fiveFamMk_SYM_Q)<-fiveFamMk_SYM$states
#run in parallel
library(parallel)
Sys.time()
setCores<-round(detectCores()*0.85) #use 85% of available logical processors
cl<-parallel::makeCluster(getOption("cl.cores",setCores))
cl.pkg<-parallel::clusterEvalQ(cl,library(phytools))
parallel::clusterExport(cl,"fiveFam_dietTree")
parallel::clusterExport(cl,"fiveFamMk_SYM_Q")
parallel::clusterExport(cl,"fiveFam_dietCats")
NRUNS<-10   #10 'runs' of nsim=50 -> 500 total simmaps
fiveFamSYM_MkParallel<-parallel::parLapply(cl=cl,1:NRUNS,function(i){
  make.simmap(fiveFam_dietTree,fiveFam_dietCats$diet,Q=fiveFamMk_SYM_Q,
              nsim=50,pi=c(1,0,0,0))
})
print("done")
stopCluster(cl)
Sys.time()
fiveFamSYM_Mk<-do.call(c,fiveFamSYM_MkParallel)
class(fiveFamSYM_Mk)<-c("multiSimmap",class(fiveFamSYM_Mk))
fiveFamSYM_Mk_summary<-summary(fiveFamSYM_Mk,plot=FALSE)
plot(fiveFamSYM_Mk_summary,colors=fourCols,type="fan",fsize=0.8,cex=c(0.1,0.1))
plotSimmap(fiveFamSYM_Mk[[1]],colors=fourCols)


#quick morphological plotting
name.check(fiveFamSYM_Mk[[1]],all.shape.2D)->overlap
maptree<-drop.tip.simmap(fiveFamSYM_Mk[[1]],overlap$tree_not_data)
phylomorphospace(maptree,fiveFam_pPCA$S[,1:2],label="none",colors=fourcolors,
                 node.by.map=TRUE,node.size=c(0,2)
                 ,xlim=c(-0.2,0.2),ylim=c(-0.2,0.2)
                 )



#####read in biogeography#####
fivefamBioGeo<-read.csv("./data/simmap_cats/allFiveFams_634sp_4cats_biogeog.csv")


######subset by region#####
#caribs
caribs<-fivefamBioGeo$species[fivefamBioGeo$Caribb=="1"]
fiveFam_pPCA$S[rownames(fiveFam_pPCA$S)%in%caribs,]->caribsdat
name.check(fiveFamSYM_Mk[[1]],caribsdat)->caribsoverlap
caribmaptree<-drop.tip.simmap(fiveFamSYM_Mk[[1]],caribsoverlap$tree_not_data)
phylomorphospace(caribmaptree,caribsdat[,1:2],label="none",colors=fourcolors,
                 node.by.map=TRUE,node.size=c(0,2)
                 ,xlim=c(-0.2,0.2),ylim=c(-0.2,0.2))
caribrepca<-phyl.pca(caribmaptree,caribsdat,method="lambda")
phylomorphospace(caribmaptree,caribrepca$S[,1:2],label="none",colors=fourcolors,
                 node.by.map=TRUE,node.size=c(0,2)
                 ,xlim=c(-0.2,0.2),ylim=c(-0.2,0.2))

caribrepca.varExpl<-rbind(
  SD = sqrt(rowSums(caribrepca$Eval)),
  Proportion = rowSums(caribrepca$Eval)/sum(rowSums(caribrepca$Eval)),
  Cumulative = cumsum(rowSums(caribrepca$Eval))/sum(rowSums(caribrepca$Eval)))
plot(1:ncol(caribrepca$S),
     caribrepca.varExpl[2,],pch=19);abline(h=mean(caribrepca.varExpl[2,]))
plot(1:ncol(caribrepca.varExpl),caribrepca.varExpl[3,],
     pch=19,ylim=c(0,1));abline(h=0.95)

#density plot for figure3e
caribrepcaPCdata<-data.frame(caribrepca$S);caribrepcaPCdata$species<-rownames(caribrepca$S)
caribrepcaPCdat_diet_geo<-left_join(caribrepcaPCdata,fivefamBioGeo,by="species")
caribrepcaPCdat_diet_geo$diet<-as.factor(caribrepcaPCdat_diet_geo$diet)

ggplot(caribrepcaPCdat_diet_geo,aes(x=PC1,y=diet)) + 
  geom_density_ridges2(aes(fill=diet),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
  #coord_cartesian(xlim=c(summary(PCdata$PC1)[1],
  #                       summary(PCdata$PC1)[6])) +
  scale_fill_manual(values = c(rep("gray80",1),rep("#ff9900",1),
                               rep("#00BA57",1),rep("#5D3BE9",1)
  )) +
  theme_ridges()


#IAAs
IAAs<-fivefamBioGeo$species[fivefamBioGeo$IAA=="1"]
fiveFam_pPCA$S[rownames(fiveFam_pPCA$S)%in%IAAs,]->IAAsdat
name.check(fiveFamSYM_Mk[[1]],IAAsdat)->IAAsoverlap
IAAsmaptree<-drop.tip.simmap(fiveFamSYM_Mk[[1]],IAAsoverlap$tree_not_data)
phylomorphospace(IAAsmaptree,IAAsdat[,1:2],label="none",colors=fourcolors,
                 node.by.map=TRUE,node.size=c(0,2)
                 ,xlim=c(-0.2,0.2),ylim=c(-0.2,0.2))
IAArepca<-phyl.pca(IAAsmaptree,IAAsdat,method="lambda")
phylomorphospace(IAAsmaptree,IAArepca$S[,1:2],label="none",colors=fourcolors,
                 node.by.map=TRUE,node.size=c(0,2)
                 ,xlim=c(-0.2,0.2),ylim=c(-0.2,0.2))

IAArepca.varExpl<-rbind(
  SD = sqrt(rowSums(IAArepca$Eval)),
  Proportion = rowSums(IAArepca$Eval)/sum(rowSums(IAArepca$Eval)),
  Cumulative = cumsum(rowSums(IAArepca$Eval))/sum(rowSums(IAArepca$Eval)))
plot(1:ncol(IAArepca$S),
     IAArepca.varExpl[2,],pch=19);abline(h=mean(IAArepca.varExpl[2,]))
plot(1:ncol(IAArepca.varExpl),IAArepca.varExpl[3,],
     pch=19,ylim=c(0,1));abline(h=0.95)

#density plot for figure3e
IAArepcaPCdata<-data.frame(IAArepca$S);IAArepcaPCdata$species<-rownames(IAArepca$S)
IAArepcaPCdat_diet_geo<-left_join(IAArepcaPCdata,fivefamBioGeo,by="species")
IAArepcaPCdat_diet_geo$diet<-as.factor(IAArepcaPCdat_diet_geo$diet)

ggplot(IAArepcaPCdat_diet_geo,aes(x=PC1,y=diet)) + 
  geom_density_ridges2(aes(fill=diet),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
  #coord_cartesian(xlim=c(summary(PCdata$PC1)[1],
  #                       summary(PCdata$PC1)[6])) +
  scale_fill_manual(values = c(rep("gray80",1),rep("#ff9900",1),
                               rep("#00BA57",1),rep("#5D3BE9",1)
  )) +
  theme_ridges()


###### simmap by family subtree#####
#simmap of surfperches
sfpDiets<-fiveFam_dietCats[fiveFam_dietCats$shortFam=='sfp',]
#sfpFitER<-fitDiscrete(sfpTree,sfpDiets$diet,model="ER")
#sfpFitSYM<-fitDiscrete(sfpTree,sfpDiets$diet,model="SYM")
#sfpFitARD<-fitDiscrete(sfpTree,sfpDiets$diet,model="ARD")
#sfpDisaicc<-c(sfpFitER$opt$aicc,sfpFitSYM$opt$aicc,sfpFitARD$opt$aicc)
#names(sfpDisaicc)<-c("ER","SYM","ARD")
#sfpDisaicc-min(sfpDisaicc) #ER is best, by a good margin
sfpMk_ER<-fitMk(sfpTree,sfpDiets$diet,model="ER",pi=c(1,0,0))
sfpMk_ER_Q<-matrix(NA,length(sfpMk_ER$states),
                        length(sfpMk_ER$states))
sfpMk_ER_Q[]<-c(0,sfpMk_ER$rates)[sfpMk_ER$index.matrix+1]
diag(sfpMk_ER_Q)<-0
diag(sfpMk_ER_Q)<--rowSums(sfpMk_ER_Q)
colnames(sfpMk_ER_Q)<-rownames(sfpMk_ER_Q)<-sfpMk_ER$states
library(parallel)
Sys.time()
setCores<-round(detectCores()*0.85) #use 85% of available logical processors
cl<-parallel::makeCluster(getOption("cl.cores",setCores))
cl.pkg<-parallel::clusterEvalQ(cl,library(phytools))
parallel::clusterExport(cl,"sfpTree")
parallel::clusterExport(cl,"sfpMk_ER")
parallel::clusterExport(cl,"sfpMk_ER_Q")
parallel::clusterExport(cl,"sfpDiets")
NRUNS<-10   #10 'runs' of nsim=50 -> 500 total simmaps
sfpMk_ER_MkParallel<-parallel::parLapply(cl=cl,1:NRUNS,function(i){
  make.simmap(ladderize(sfpTree),sfpDiets$diet,Q=sfpMk_ER_Q,
              nsim=50,pi=c(1,0,0))
})
print("done")
stopCluster(cl)
Sys.time()
sfpMk_ER_Mk<-do.call(c,sfpMk_ER_MkParallel)
class(sfpMk_ER_Mk)<-c("multiSimmap",class(sfpMk_ER_Mk))
sfp_mapsummary<-summary(sfpMk_ER_Mk,plot=FALSE)
plot(sfp_mapsummary,colors=fourCols,ftype="off",cex=c(0.2,0.2),type="fan")
axisPhylo(side=1,root.time=NULL,backward=TRUE)
plotSimmap(sfpMk_ER_Mk[[1]],colors=fourCols) 
markChanges(sfpMk_ER_Mk[[1]],colors=fourCols)

sfp_obj<-sapply(sfpMk_ER_Mk,markChanges,colors=sapply(fourCols,make.transparent,alpha=0.1))
sfp_X<-unlist(sapply(sfp_obj,function(x) x[,1]))
sfp_tmpJuv<-data.frame(time=max(branching.times(sfpTree))-sfp_X[names(sfp_X)=="1->2"])
sfp_tmpJuv$trans<-"nonJuv"
sfp_tmpFac<-data.frame(time=max(branching.times(sfpTree))-sfp_X[names(sfp_X)=="1->3"])
sfp_tmpFac$trans<-"nonFac"
sfp_trans<-rbind(sfp_tmpJuv,sfp_tmpFac) 
sfp_trans$fam<-"sfp"
sfp_transplot <- ggplot(sfp_trans, aes(x=time,fill=trans)) +  
  geom_density(alpha=0.8) +
  scale_fill_manual(values=c("#00BA57","#ff9900")) +
  scale_x_reverse()+
  theme_ridges()
sfp_transplot
quantile(sfp_trans$time,probs=c(0.05,0.5,0.95))

#alternatively
dotTree(ladderize(sfpTree),sfpDiets$diet,colors=fourCols)
mt<-phytools:::make.transparent ## using the internal function 
nulo<-sapply(sfpMk_ER_Mk,markChanges,sapply(fourCols,mt,0.4))
nodelabels(pie=sfp_mapsummary$ace,cex=0.6,piecol=fourCols)

#simmap of gobies
gobDiets<-fiveFam_dietCats[fiveFam_dietCats$shortFam=='gob',]
#gobFitER<-fitDiscrete(gobTree,gobDiets$diet,model="ER")
#gobFitSYM<-fitDiscrete(gobTree,gobDiets$diet,model="SYM")
#gobFitARD<-fitDiscrete(gobTree,gobDiets$diet,model="ARD")
#gobDisaicc<-c(gobFitER$opt$aicc,gobFitSYM$opt$aicc,gobFitARD$opt$aicc)
#names(gobDisaicc)<-c("ER","SYM","ARD")
#gobDisaicc-min(gobDisaicc) #SYM is best
gobMk_SYM<-fitMk(gobTree,gobDiets$diet,model="SYM",pi=c(1,0,0))
gobMk_SYM_Q<-matrix(NA,length(gobMk_SYM$states),
                    length(gobMk_SYM$states))
gobMk_SYM_Q[]<-c(0,gobMk_SYM$rates)[gobMk_SYM$index.matrix+1]
diag(gobMk_SYM_Q)<-0
diag(gobMk_SYM_Q)<--rowSums(gobMk_SYM_Q)
colnames(gobMk_SYM_Q)<-rownames(gobMk_SYM_Q)<-gobMk_SYM$states
library(parallel)
Sys.time()
setCores<-round(detectCores()*0.85) #use 85% of available logical processors
cl<-parallel::makeCluster(getOption("cl.cores",setCores))
cl.pkg<-parallel::clusterEvalQ(cl,library(phytools))
parallel::clusterExport(cl,"gobTree")
parallel::clusterExport(cl,"gobMk_SYM")
parallel::clusterExport(cl,"gobMk_SYM_Q")
parallel::clusterExport(cl,"gobDiets")
NRUNS<-10   #10 'runs' of nsim=50 -> 500 total simmaps
gobMk_SYM_MkParallel<-parallel::parLapply(cl=cl,1:NRUNS,function(i){
  make.simmap(ladderize(gobTree),gobDiets$diet,Q=gobMk_SYM_Q,
              nsim=50,pi=c(1,0,0))
})
print("done")
stopCluster(cl)
Sys.time()
gobMk_SYM_Mk<-do.call(c,gobMk_SYM_MkParallel)
class(gobMk_SYM_Mk)<-c("multiSimmap",class(gobMk_SYM_Mk))
gob_mapsummary<-summary(gobMk_SYM_Mk,plot=FALSE)
plot(gob_mapsummary,colors=fourCols,ftype="off",cex=c(0.2,0.2),type="fan")
axisPhylo(side=1,root.time=NULL,backward=TRUE)
plotSimmap(gobMk_SYM_Mk[[1]],colors=fourCols) 
markChanges(gobMk_SYM_Mk[[1]],colors=fourCols)

gob_obj<-sapply(gobMk_SYM_Mk,markChanges,colors=sapply(fourCols,make.transparent,alpha=0.1))
gob_X<-unlist(sapply(gob_obj,function(x) x[,1]))
gob_tmpFac<-data.frame(time=max(branching.times(gobTree))-gob_X[names(gob_X)=="1->3"])
gob_tmpFac$trans<-"nonFac"
gob_tmpOblFac<-data.frame(time=max(branching.times(gobTree))-gob_X[names(gob_X)=="4->3"])
gob_tmpOblFac$trans<-"nonFac"
gob_tmpObl<-data.frame(time=max(branching.times(gobTree))-gob_X[names(gob_X)=="1->4"])
gob_tmpObl$trans<-"nonObl"
gob_tmpFacObl<-data.frame(time=max(branching.times(gobTree))-gob_X[names(gob_X)=="3->4"])
gob_tmpFacObl$trans<-"nonObl"
gob_trans<-rbind(gob_tmpFac,gob_tmpObl)
gob_trans<-rbind(gob_tmpFac,gob_tmpOblFac,
                 gob_tmpObl,gob_tmpFacObl)
gob_trans$fam<-"gob"
gob_transplot <- ggplot(gob_trans, aes(x=time,fill=trans)) +  
  geom_density(alpha=0.8) +
  scale_fill_manual(values=c("#00BA57","#5D3BE9"
  )) +
  scale_x_reverse()+
  theme_ridges()
gob_transplot
quantile(gob_trans$time,probs=c(0.05,0.5,0.95))

dotTree(ladderize(gobTree),gobDiets$diet,colors=fourCols)
axisPhylo(side=1,root.time=NULL,backward=TRUE)
mt<-phytools:::make.transparent ## using the internal function 
nulo<-sapply(gobMk_SYM_Mk,markChanges,sapply(fourCols,mt,0.4))
nodelabels(pie=gob_mapsummary$ace,cex=0.6,piecol=fourCols)

#simmap of angels
angDiets<-fiveFam_dietCats[fiveFam_dietCats$shortFam=='ang',]
#angFitER<-fitDiscrete(angTree,angDiets$diet,model="ER")
#angFitSYM<-fitDiscrete(angTree,angDiets$diet,model="SYM")
#angFitARD<-fitDiscrete(angTree,angDiets$diet,model="ARD")
#angDisaicc<-c(angFitER$opt$aicc,angFitSYM$opt$aicc,angFitARD$opt$aicc)
#names(angDisaicc)<-c("ER","SYM","ARD")
angDisaicc-min(angDisaicc) #SYM is best, by a good margin
angMk_SYM<-fitMk(angTree,angDiets$diet,model="SYM",pi=c(1,0))
angMk_SYM_Q<-matrix(NA,length(angMk_SYM$states),
                    length(angMk_SYM$states))
angMk_SYM_Q[]<-c(0,angMk_SYM$rates)[angMk_SYM$index.matrix+1]
diag(angMk_SYM_Q)<-0
diag(angMk_SYM_Q)<--rowSums(angMk_SYM_Q)
colnames(angMk_SYM_Q)<-rownames(angMk_SYM_Q)<-angMk_SYM$states
library(parallel)
Sys.time()
setCores<-round(detectCores()*0.85) #use 85% of available logical processors
cl<-parallel::makeCluster(getOption("cl.cores",setCores))
cl.pkg<-parallel::clusterEvalQ(cl,library(phytools))
parallel::clusterExport(cl,"angTree")
parallel::clusterExport(cl,"angMk_SYM")
parallel::clusterExport(cl,"angMk_SYM_Q")
parallel::clusterExport(cl,"angDiets")
NRUNS<-10   #10 'runs' of nsim=50 -> 500 total simmaps
angMk_SYM_MkParallel<-parallel::parLapply(cl=cl,1:NRUNS,function(i){
  make.simmap(ladderize(angTree),angDiets$diet,Q=angMk_SYM_Q,
              nsim=50,pi=c(1,0))
})
print("done")
stopCluster(cl)
Sys.time()
angMk_SYM_Mk<-do.call(c,angMk_SYM_MkParallel)
class(angMk_SYM_Mk)<-c("multiSimmap",class(angMk_SYM_Mk))
ang_mapsummary<-summary(angMk_SYM_Mk,plot=FALSE)
plot(ang_mapsummary,colors=fourCols,ftype="off",cex=c(0.2,0.2),type="fan")
axisPhylo(side=1,root.time=NULL,backward=TRUE)
plotSimmap(angMk_SYM_Mk[[1]],colors=fourCols) 
markChanges(angMk_SYM_Mk[[1]],colors=fourCols)

ang_obj<-sapply(angMk_SYM_Mk,markChanges,colors=sapply(fourCols,make.transparent,alpha=0.1))
ang_X<-unlist(sapply(ang_obj,function(x) x[,1]))
ang_trans<-data.frame(time=max(branching.times(angTree))-ang_X[names(ang_X)=="1->2"]) 
ang_trans$trans<-"nonJuv"
ang_trans$fam<-"ang"
ang_transplot <- ggplot(ang_trans, aes(x=time)) +  
  geom_density(alpha=0.8,fill=fourCols[2]) +
  scale_x_reverse()+
  theme_ridges()
ang_transplot
quantile(ang_trans$time,probs=c(0.05,0.5,0.95))


#simmap of damsels
damDiets<-fiveFam_dietCats[fiveFam_dietCats$shortFam=='dam',]
#damFitER<-fitDiscrete(damTree,damDiets$diet,model="ER")
#damFitSYM<-fitDiscrete(damTree,damDiets$diet,model="SYM")
#damFitARD<-fitDiscrete(damTree,damDiets$diet,model="ARD")
#damDisaicc<-c(damFitER$opt$aicc,damFitSYM$opt$aicc,damFitARD$opt$aicc)
#names(damDisaicc)<-c("ER","SYM","ARD")
#damDisaicc-min(damDisaicc) #ARD is best, by a good margin
damMk_ARD<-fitMk(damTree,damDiets$diet,model="ARD",pi=c(1,0))
damMk_ARD_Q<-matrix(NA,length(damMk_ARD$states),
                    length(damMk_ARD$states))
damMk_ARD_Q[]<-c(0,damMk_ARD$rates)[damMk_ARD$index.matrix+1]
diag(damMk_ARD_Q)<-0
diag(damMk_ARD_Q)<--rowSums(damMk_ARD_Q)
colnames(damMk_ARD_Q)<-rownames(damMk_ARD_Q)<-damMk_ARD$states
library(parallel)
Sys.time()
setCores<-round(detectCores()*0.85) #use 85% of available logical processors
cl<-parallel::makeCluster(getOption("cl.cores",setCores))
cl.pkg<-parallel::clusterEvalQ(cl,library(phytools))
parallel::clusterExport(cl,"damTree")
parallel::clusterExport(cl,"damMk_ARD")
parallel::clusterExport(cl,"damMk_ARD_Q")
parallel::clusterExport(cl,"damDiets")
NRUNS<-10   #10 'runs' of nsim=50 -> 500 total simmaps
damMk_ARD_MkParallel<-parallel::parLapply(cl=cl,1:NRUNS,function(i){
  make.simmap(ladderize(damTree),damDiets$diet,Q=damMk_ARD_Q,
              nsim=50,pi=c(1,0))
})
print("done")
stopCluster(cl)
Sys.time()
damMk_ARD_Mk<-do.call(c,damMk_ARD_MkParallel)
class(damMk_ARD_Mk)<-c("multiSimmap",class(damMk_ARD_Mk))
dam_mapsummary<-summary(damMk_ARD_Mk,plot=FALSE)
plot(dam_mapsummary,colors=fourCols,ftype="off",cex=c(0.2,0.2),type="fan")
axisPhylo(side=1,root.time=NULL,backward=TRUE)
plotSimmap(damMk_ARD_Mk[[1]],colors=fourCols) 
markChanges(damMk_ARD_Mk[[1]],colors=fourCols)

dam_obj<-sapply(damMk_ARD_Mk,markChanges,colors=sapply(fourCols,make.transparent,alpha=0.1))
dam_X<-unlist(sapply(dam_obj,function(x) x[,1]))
dam_trans<-data.frame(time=max(branching.times(damTree))-dam_X[names(dam_X)=="1->2"])
dam_trans$trans<-"nonJuv"
dam_trans$fam<-"dam"
dam_transplot <- ggplot(dam_trans, aes(x=time)) +  
  geom_density(alpha=0.8,fill=fourCols[2]) +
  scale_x_reverse()+
  theme_ridges()
dam_transplot
quantile(dam_trans$time,probs=c(0.05,0.5,0.95))


#simmap of labrids
labDiets<-fiveFam_dietCats[fiveFam_dietCats$shortFam=='lab',]
#labFitER<-fitDiscrete(labTree,labDiets$diet,model="ER")
#labFitSYM<-fitDiscrete(labTree,labDiets$diet,model="SYM")
#labFitARD<-fitDiscrete(labTree,labDiets$diet,model="ARD")
#labDisaicc<-c(labFitER$opt$aicc,labFitSYM$opt$aicc,labFitARD$opt$aicc)
#names(labDisaicc)<-c("ER","SYM","ARD")
#labDisaicc-min(labDisaicc) #SYM is best, by a good margin
#labMk_SYM<-fitMk(labTree,labDiets$diet,model="SYM",pi=c(1,0,0,0))
#labMk_SYM_Q<-matrix(NA,length(labMk_SYM$states),
#                   length(labMk_SYM$states))
#labMk_SYM_Q[]<-c(0,labMk_SYM$rates)[labMk_SYM$index.matrix+1]
#diag(labMk_SYM_Q)<-0
#diag(labMk_SYM_Q)<--rowSums(labMk_SYM_Q)
#colnames(labMk_SYM_Q)<-rownames(labMk_SYM_Q)<-labMk_SYM$states
labMk_SYM_Q<-rbind(c(-0.00913067,0.008056395,0.001074275,2.879524E-19),
                   c(0.008056395,-0.03192472,0.01992938,0.003938948),
                   c(0.006749426875,0.015739179425,-0.02248860375,2.55000000004557E-09),
                   c(3.512076E-26,0.0203573,1.522261E-20,-0.0203573))
rownames(labMk_SYM_Q)=1:4
colnames(labMk_SYM_Q)=1:4
library(parallel)
Sys.time()
setCores<-round(detectCores()*0.85) #use 85% of available logical processors
cl<-parallel::makeCluster(getOption("cl.cores",setCores))
cl.pkg<-parallel::clusterEvalQ(cl,library(phytools))
parallel::clusterExport(cl,"labTree")
parallel::clusterExport(cl,"labMk_SYM")
parallel::clusterExport(cl,"labMk_SYM_Q")
parallel::clusterExport(cl,"labDiets")
NRUNS<-10   #10 'runs' of nsim=50 -> 500 total simmaps
labMk_SYM_MkParallel<-parallel::parLapply(cl=cl,1:NRUNS,function(i){
  make.simmap(ladderize(labTree),labDiets$diet,Q=labMk_SYM_Q,
              nsim=50,pi=c(1,0,0,0))
})
print("done")
stopCluster(cl)
Sys.time()
labMk_SYM_Mk<-do.call(c,labMk_SYM_MkParallel)
class(labMk_SYM_Mk)<-c("multiSimmap",class(labMk_SYM_Mk))
lab_mapsummary<-summary(labMk_SYM_Mk,plot=FALSE)
plot(lab_mapsummary,colors=fourCols,ftype="off",cex=c(0.2,0.2),type="fan")
axisPhylo(side=1,root.time=NULL,backward=TRUE)
plotSimmap(labMk_SYM_Mk[[1]],colors=fourCols) 
markChanges(labMk_SYM_Mk[[1]],colors=fourCols)

lab_obj<-sapply(labMk_SYM_Mk,markChanges,colors=sapply(fourCols,make.transparent,alpha=0.1))
lab_X<-unlist(sapply(lab_obj,function(x) x[,1]))
lab_tmpJuv<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="1->2"])
lab_tmpJuv$trans<-"nonJuv"
lab_tmpFacJuv<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="3->2"])
lab_tmpFacJuv$trans<-"nonJuv"
lab_tmpOblJuv<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="4->2"])
lab_tmpOblJuv$trans<-"nonJuv"
lab_tmpFac<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="1->3"])
lab_tmpFac$trans<-"nonFac"
lab_tmpJuvFac<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="2->3"])
lab_tmpJuvFac$trans<-"nonFac"
lab_tmpOblFac<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="4->3"])
lab_tmpOblFac$trans<-"nonFac"
lab_tmpObl<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="1->4"])
lab_tmpObl$trans<-"nonObl"
lab_tmpFacObl<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="3->4"])
lab_tmpFacObl$trans<-"nonObl"
lab_tmpJuvObl<-data.frame(time=max(branching.times(labTree))-lab_X[names(lab_X)=="2->4"])
lab_tmpJuvObl$trans<-"nonObl"
lab_trans<-rbind(lab_tmpJuv,lab_tmpFac,lab_tmpObl)
lab_trans<-rbind(lab_tmpJuv,lab_tmpFacJuv,lab_tmpOblJuv,
                 lab_tmpFac,lab_tmpJuvFac,lab_tmpOblFac,
                 lab_tmpObl,lab_tmpFacObl,lab_tmpJuvObl)
lab_trans$fam<-"lab"
lab_transplot <- ggplot(lab_trans, aes(x=time,fill=trans)) +  
  geom_density(alpha=0.8) +
  scale_fill_manual(values=c("#00BA57","#ff9900"
                             ,"#5D3BE9"
                             )) +
  scale_x_reverse()+
  theme_ridges()
lab_transplot
quantile(lab_trans$time,probs=c(0.05,0.5,0.95))

#collect all time plots and make common
all_trans<-rbind(sfp_trans,gob_trans,ang_trans,dam_trans,lab_trans)
all_trans%>%mutate(var=fct_reorder(fam,time,fun=modeStat))->all_trans_rord
ggplot(all_trans_rord,aes(x=time,y=fam)) + 
  geom_density_ridges2(aes(fill=fam),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
  coord_cartesian(xlim=c(summary(all_trans_rord$time)[1],
                         summary(all_trans_rord$time)[6])) +
  scale_x_reverse()+
  scale_fill_manual(values = c(rep("#F16622",1),rep("#069F77",1),
                               rep("#0BB6EA",1),rep("#F9A31A",1),
                               rep("#E07CAA",1)
                               )) +
  theme_ridges()


ggplot(all_trans_rord,aes(x=time)) + 
  geom_density_ridges2(aes(x=time,y=..density..),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
  coord_cartesian(xlim=c(summary(all_trans_rord$time)[1],
                         summary(all_trans_rord$time)[6])) +
  scale_x_reverse()+
  scale_fill_manual(values = c(rep("#000000",1))) +
  theme_ridges()
quantile(all_trans_rord$time,probs=c(0.05,0.5,0.95))        

labgob_trans<-rbind(gob_trans,lab_trans)
labgob_trans%>%mutate(var=fct_reorder(fam,time,fun=modeStat))->labgob_trans_rord
ggplot(labgob_trans_rord,aes(x=time,y=fam)) + 
  geom_density_ridges2(aes(fill=fam),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
  coord_cartesian(xlim=c(summary(all_trans_rord$time)[1],
                         summary(all_trans_rord$time)[6])) +
  scale_x_reverse()+
  scale_fill_manual(values = c(rep("#F16622",1),#rep("#069F77",1),
                               #rep("#0BB6EA",1),rep("#F9A31A",1),
                               rep("#E07CAA",1)
  )) +
  theme_ridges()


#density plot for figure3d
PCdata<-data.frame(fiveFam_pPCA$S);PCdata$species<-rownames(fiveFam_pPCA$S)
PCdat_diet_geo<-left_join(PCdata,fivefamBioGeo,by="species")
PCdat_diet_geo$diet<-as.factor(PCdat_diet_geo$diet)

ggplot(PCdat_diet_geo,aes(x=PC1,y=diet)) + 
  geom_density_ridges2(aes(fill=diet),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
  #coord_cartesian(xlim=c(summary(PCdata$PC1)[1],
  #                       summary(PCdata$PC1)[6])) +
  scale_fill_manual(values = c(rep("gray80",1),rep("#ff9900",1),
                               rep("#00BA57",1),rep("#5D3BE9",1)
  )) +
  theme_ridges()


######GBIF#######
list<-rownames(fiveFam_pPCA$S)
dat <- occ(query = list, from = 'gbif', has_coords = TRUE, limit = 10)
map_plot(dat, pch = 10)

obs<-names(fiveFam_dietCats[,2][fiveFam_dietCats[,2]=="4"])
obsdat <- occ(query = obs, from = 'gbif', has_coords = TRUE, limit = 10000)
map_plot(obsdat, pch = 10,color=c(rep("#5D3BE9",length(obsdat$gbif$data))))
map_leaflet(obsdat, pch = 10,color=c(rep("#5D3BE9",length(obsdat$gbif$data))))

facs<-names(fiveFam_dietCats[,2][fiveFam_dietCats[,2]=="3"])
facsdat <- occ(query = facs, from = 'gbif', has_coords = TRUE, limit = 10000)
map_plot(facsdat, pch = 10,color=c(rep("#00BA57",length(facsdat$gbif$data))))

juvs<-names(fiveFam_dietCats[,2][fiveFam_dietCats[,2]=="2"])
juvsdat <- occ(query = juvs, from = 'gbif', has_coords = TRUE, limit = 5000)
map_plot(juvsdat, pch = 10,color=c(rep("#FF9900",length(juvsdat$gbif$data))))

nons<-names(fiveFam_dietCats[,2][fiveFam_dietCats[,2]=="1"])
nonsdat <- occ(query = nons, from = 'gbif', has_coords = TRUE, limit = 10)
map_plot(nonsdat, pch = 10,color=c(rep("#b3b3b3",538)))


caribs<-rownames(caribrepca$S)
caribsgbif <- occ(query = caribs, from = 'gbif', has_coords = TRUE, limit = 100)
map_plot(caribsgbif, pch = 10,color=c(rep("#5D3BE9",length(caribsgbif$gbif$data))))
map_leaflet(caribsgbif, pch = 10,color=c(rep("#5D3BE9",length(caribsgbif$gbif$data))))

IAAsps<-rownames(IAArepca$S)
IAAspsgbif <- occ(query = IAAsps, from = 'gbif', has_coords = TRUE, limit = 100)
map_plot(IAAspsgbif, pch = 10,color=c(rep("#5D3BE9",length(IAAspsgbif$gbif$data))))
map_leaflet(IAAspsgbif, pch = 10,color=c(rep("#5D3BE9",length(IAAspsgbif$gbif$data))))

labroidesdat<-occ(query=obs[7:11],from='gbif',has_coords=TRUE,limit=10000)
map_plot(labroidesdat,pch=10)

labroidesdat<-occ(query="Labroides",from='gbif',has_coords=TRUE,limit=10000)
map_plot(labroidesdat,pch=10)

elacatinusdat<-occ(query=obs[1:6],from='gbif',has_coords=TRUE,limit=10000)
map_plot(elacatinusdat,pch=10)