BodySizeRaw<-read.csv("./data/body_size/LabridsGobies_BodySize.csv")
hist(BodySizeRaw$Max.cm.TL,breaks=500)
rownames(BodySizeRaw)<-BodySizeRaw[,1]

name.check(fiveFamSYM_Mk[[1]],BodySizeRaw)->BSoverlap
BSmaptree<-drop.tip.simmap(fiveFamSYM_Mk[[1]],BSoverlap$tree_not_data)
BodySizeRaw[rownames(BodySizeRaw)%in%BSmaptree$tip.label,]->tmp
obj<-tmp$Max.cm.TL;names(obj)<-rownames(tmp)
phenogram(BSmaptree,log(obj),fsize=0,spread.labels=FALSE,colors=fourCols)

#gobies first
name.check(gobMk_SYM_Mk[[1]],BodySizeRaw[BodySizeRaw$Family=="Gobiidae",])->gobBSoverlap
gobBSmaptree<-drop.tip.simmap(gobMk_SYM_Mk[[1]],gobBSoverlap$tree_not_data)
BodySizeRaw[rownames(BodySizeRaw)%in%gobBSmaptree$tip.label,]->gobtmp
gobobj<-log(gobtmp$Max.cm.TL);names(gobobj)<-rownames(gobtmp)
gobBSanc<-anc.ML(gobBSmaptree,gobobj,model="OU")
c(gobobj,gobBSanc$ace)->gobtry
phenogram(gobBSmaptree,gobtry,fsize=0.5,spread.labels=FALSE,colors=fourCols)
phylosig(gobBSmaptree,gobtry,method="lambda",test=TRUE) #0.8960563


#OUwie prep
gobOUwieDat<-left_join(gobDiets[,1:2],gobtmp[,c(1,3)],by="species")
as.factor(gobOUwieDat$diet)->gobOUwieDat$diet
log(gobOUwieDat$Max.cm.TL)->gobOUwieDat$Max.cm.TL

#OUwie 
mods<-c("BM1","BMS","OU1","OUM")
gobyBS_results<-list()

ptm<-proc.time()
for(i in 1:length(gobMk_SYM_Mk)){ 
  print(i) 
  resmat<-matrix(nrow=21, ncol=4) 
  colnames(resmat)<-c("BM1","BMS","OU1","OUM")
  row.names(resmat)<-c("loglik", "AICc", "NON_alph", "NON_alphaSE","NON_sigma", "NON_sigmaSE", "FAC_alph", "FAC_alphaSE","FAC_sigma", "FAC_sigmaSE", "OBL_alph", "OBL_alphaSE","OBL_sigma", "OBL_sigmaSE", "NON_theta", "NON_thetaSE", "FAC_theta", "FAC_thetaSE", "OBL_theta", "OBL_thetaSE", "MLStatus")
  for(j in 3:4){ # running OU models first
    tmpres<-OUwie(gobMk_SYM_Mk[[i]], gobOUwieDat, model=mods[j], simmap.tree=TRUE, root.station=TRUE, diagn=T) 
    ev<-vector()
    for(k in 1:length(tmpres$eigval)) if (tmpres$eigval[k]>0) ev<-c(ev,0) else ev<-c(ev,1) 
    eval<-vector()
    if(sum(ev)==0) eval<-"All eigenvalues positive" else eval<-"Some eigenvalues negative"
    row.names(tmpres$theta)<-colnames(tmpres$solution)
    tmpres$theta<-tmpres$theta[order(row.names(tmpres$theta)),]
    tmpres$solution<-tmpres$solution[,order(colnames(tmpres$solution))]
    tmpres$solution.se<-tmpres$solution.se[,order(colnames(tmpres$solution.se))]
    resmat[,j]<-c(tmpres$loglik, tmpres$AICc, tmpres$solution[1], tmpres$solution.se[1], tmpres$solution[2], tmpres$solution.se[2], tmpres$solution[3], tmpres$solution.se[3], tmpres$solution[4], tmpres$solution.se[4], tmpres$solution[5], tmpres$solution.se[5], tmpres$solution[6], tmpres$solution.se[6],tmpres$theta[1,], tmpres$theta[2,], tmpres$theta[3,], eval)
  }
  for(l in 1:2){ 
    tmpres<-OUwie(gobMk_SYM_Mk[[i]], gobOUwieDat, model=mods[l], simmap.tree=TRUE, root.station=TRUE, diagn=T) 
    ev<-vector()
    for(k in 1:length(tmpres$eigval)) if (tmpres$eigval[k]>0) ev<-c(ev,0) else ev<-c(ev,1) 
    eval<-vector()
    if(sum(ev)==0) eval<-"All eigenvalues positive" else eval<-"Some eigenvalues negative" 
    tmpres$solution<-tmpres$solution[,order(colnames(tmpres$solution))]
    tmpres$solution.se<-tmpres$solution.se[,order(colnames(tmpres$solution.se))]
    resmat[,l]<-c(tmpres$loglik, tmpres$AICc, tmpres$solution[1], tmpres$solution.se[1], tmpres$solution[2], tmpres$solution.se[2], tmpres$solution[3], tmpres$solution.se[3], tmpres$solution[4], tmpres$solution.se[4], tmpres$solution[5], tmpres$solution.se[5], tmpres$solution[6], tmpres$solution.se[6],0,0,0,0,0,0,eval)# 0's are for the thetas
  }
  
  gobyBS_results[[i]]<-resmat
}
proc.time()-ptm

gobyBS_errors<-matrix(nrow=length(gobyBS_results), ncol=ncol(gobyBS_results[[1]]))
colnames(gobyBS_errors)<-colnames(gobyBS_results[[1]])
for(i in 1:length(gobyBS_results)) gobyBS_errors[i,]<-gobyBS_results[[i]][21,]

gobyBS_deltAICctable<-matrix(nrow=length(gobyBS_results), ncol=ncol(gobyBS_results[[1]]))
colnames(gobyBS_deltAICctable)<-colnames(gobyBS_results[[1]])
for(i in 1:length(gobyBS_results)) gobyBS_deltAICctable[i,]<-as.numeric(gobyBS_results[[i]][2,])-min(as.numeric(gobyBS_results[[i]][2,]))
colMeans(gobyBS_deltAICctable)

gobyBS_AICctable<-matrix(nrow=length(gobyBS_results), ncol=ncol(gobyBS_results[[1]]))
colnames(gobyBS_AICctable)<-colnames(gobyBS_results[[1]])
for(i in 1:length(gobyBS_results)) gobyBS_AICctable[i,]<-as.numeric(gobyBS_results[[i]][2,])
colMeans(gobyBS_AICctable)

gobyBS_logLik<-matrix(nrow=length(gobyBS_results), ncol=ncol(gobyBS_results[[1]]))
colnames(gobyBS_logLik)<-colnames(gobyBS_results[[1]])
for(i in 1:length(gobyBS_results)) gobyBS_logLik[i,]<-as.numeric(gobyBS_results[[i]][1,])
colMeans(gobyBS_logLik)

gobyBS_OU1optima<-vector()
for(i in 1:length(gobyBS_results)){ # creating vectors that include the estimates for all 11 trees
  gobyBS_OU1optima<-c(gobyBS_OU1optima,as.numeric(gobyBS_results[[i]][15,3]))
}
gobyBS_OU1alpha<-vector()
for(i in 1:length(gobyBS_results)){ # creating vectors that include the estimates for all 11 trees
  gobyBS_OU1alpha<-c(gobyBS_OU1alpha,as.numeric(gobyBS_results[[i]][3,3]))
}
gobyBS_OU1sigma<-vector()
for(i in 1:length(gobyBS_results)){ # creating vectors that include the estimates for all 11 trees
  gobyBS_OU1sigma<-c(gobyBS_OU1sigma,as.numeric(gobyBS_results[[i]][5,3]))
}



##labrids
name.check(labMk_SYM_Mk[[1]],BodySizeRaw[BodySizeRaw$Family=="Labridae",])->labBSoverlap
labBSmaptree<-drop.tip.simmap(labMk_SYM_Mk[[1]],labBSoverlap$tree_not_data)
BodySizeRaw[rownames(BodySizeRaw)%in%labBSmaptree$tip.label,]->labtmp
labobj<-log(labtmp$Max.cm.TL);names(labobj)<-rownames(labtmp)
phenogram(labBSmaptree,labobj,fsize=0.5,spread.labels=FALSE,colors=fourCols)
phylosig(labBSmaptree,labobj,method="lambda",test=TRUE) #0.8539866

#OUwie prep
labOUwieDat<-left_join(labDiets[,1:2],labtmp[,c(1,3)],by="species")
labOUwieDat$diet[labOUwieDat$diet=="2"]<-"1"
as.factor(labOUwieDat$diet)->labOUwieDat$diet
log(labOUwieDat$Max.cm.TL)->labOUwieDat$Max.cm.TL

#merge mapped states
labMk_SYM_Mk_merged<-lapply(labMk_SYM_Mk,mergeMappedStates,"2","1")
plotSimmap(labMk_SYM_Mk_merged[[5]],colors=fourCols,fsize=0.5,ftype="i")
phenogram(labMk_SYM_Mk_merged[[5]],labobj,fsize=0.5,spread.labels=FALSE,colors=fourCols)

#OUwie 
mods<-c("BM1","BMS","OU1","OUM")
labBS_results<-list()

ptm<-proc.time()
for(i in 1:length(labMk_SYM_Mk)){ 
  print(i) 
  resmat<-matrix(nrow=21, ncol=4) 
  colnames(resmat)<-c("BM1","BMS","OU1","OUM")
  row.names(resmat)<-c("loglik", "AICc", "NON_alph", "NON_alphaSE","NON_sigma", "NON_sigmaSE", "FAC_alph", "FAC_alphaSE","FAC_sigma", "FAC_sigmaSE", "OBL_alph", "OBL_alphaSE","OBL_sigma", "OBL_sigmaSE", "NON_theta", "NON_thetaSE", "FAC_theta", "FAC_thetaSE", "OBL_theta", "OBL_thetaSE", "MLStatus")
  for(j in 3:4){ # running OU models first
    tmpres<-OUwie(labMk_SYM_Mk_merged[[i]], labOUwieDat, model=mods[j], simmap.tree=TRUE, root.station=TRUE, diagn=T) 
    ev<-vector()
    for(k in 1:length(tmpres$eigval)) if (tmpres$eigval[k]>0) ev<-c(ev,0) else ev<-c(ev,1) 
    eval<-vector()
    if(sum(ev)==0) eval<-"All eigenvalues positive" else eval<-"Some eigenvalues negative"
    row.names(tmpres$theta)<-colnames(tmpres$solution)
    tmpres$theta<-tmpres$theta[order(row.names(tmpres$theta)),]
    tmpres$solution<-tmpres$solution[,order(colnames(tmpres$solution))]
    tmpres$solution.se<-tmpres$solution.se[,order(colnames(tmpres$solution.se))]
    resmat[,j]<-c(tmpres$loglik, tmpres$AICc, tmpres$solution[1], tmpres$solution.se[1], tmpres$solution[2], tmpres$solution.se[2], tmpres$solution[3], tmpres$solution.se[3], tmpres$solution[4], tmpres$solution.se[4], tmpres$solution[5], tmpres$solution.se[5], tmpres$solution[6], tmpres$solution.se[6],tmpres$theta[1,], tmpres$theta[2,], tmpres$theta[3,], eval)
  }
  for(l in 1:2){ 
    tmpres<-OUwie(labMk_SYM_Mk_merged[[i]], labOUwieDat, model=mods[l], simmap.tree=TRUE, root.station=TRUE, diagn=T) 
    ev<-vector()
    for(k in 1:length(tmpres$eigval)) if (tmpres$eigval[k]>0) ev<-c(ev,0) else ev<-c(ev,1) 
    eval<-vector()
    if(sum(ev)==0) eval<-"All eigenvalues positive" else eval<-"Some eigenvalues negative" 
    tmpres$solution<-tmpres$solution[,order(colnames(tmpres$solution))]
    tmpres$solution.se<-tmpres$solution.se[,order(colnames(tmpres$solution.se))]
    resmat[,l]<-c(tmpres$loglik, tmpres$AICc, tmpres$solution[1], tmpres$solution.se[1], tmpres$solution[2], tmpres$solution.se[2], tmpres$solution[3], tmpres$solution.se[3], tmpres$solution[4], tmpres$solution.se[4], tmpres$solution[5], tmpres$solution.se[5], tmpres$solution[6], tmpres$solution.se[6],0,0,0,0,0,0,eval)# 0's are for the thetas
  }
  
  labBS_results[[i]]<-resmat
}
proc.time()-ptm

labBS_errors<-matrix(nrow=length(labBS_results), ncol=ncol(labBS_results[[1]])) #replace with length(labMergedBSTrees)
colnames(labBS_errors)<-colnames(labBS_results[[1]])
for(i in 1:length(labBS_results)) labBS_errors[i,]<-labBS_results[[i]][21,]

labBS_deltAICctable<-matrix(nrow=length(labBS_results), ncol=ncol(labBS_results[[1]]))
colnames(labBS_deltAICctable)<-colnames(labBS_results[[1]])
for(i in 1:length(labBS_results)) labBS_deltAICctable[i,]<-as.numeric(labBS_results[[i]][2,])-min(as.numeric(labBS_results[[i]][2,]))
colMeans(labBS_deltAICctable)

labBS_AICctable<-matrix(nrow=length(labBS_results), ncol=ncol(labBS_results[[1]]))
colnames(labBS_AICctable)<-colnames(labBS_results[[1]])
for(i in 1:length(labBS_results)) labBS_AICctable[i,]<-as.numeric(labBS_results[[i]][2,])
colMeans(labBS_AICctable)# you can see the best-fitting model is not the one found with the maximum likelihood reconstructions at the node

labBS_logLik<-matrix(nrow=length(labBS_results), ncol=ncol(labBS_results[[1]]))
colnames(labBS_logLik)<-colnames(labBS_results[[1]])
for(i in 1:length(labBS_results)) labBS_logLik[i,]<-as.numeric(labBS_results[[i]][1,])
colMeans(labBS_logLik)


labBS_OU1optima<-vector()
for(i in 1:length(labBS_results)){ # creating vectors that include the estimates for all 11 trees
  labBS_OU1optima<-c(labBS_OU1optima,as.numeric(labBS_results[[i]][15,3]))
}
labBS_OU1alpha<-vector()
for(i in 1:length(labBS_results)){ # creating vectors that include the estimates for all 11 trees
  labBS_OU1alpha<-c(labBS_OU1alpha,as.numeric(labBS_results[[i]][3,3]))
}
labBS_OU1sigma<-vector()
for(i in 1:length(labBS_results)){ # creating vectors that include the estimates for all 11 trees
  labBS_OU1sigma<-c(labBS_OU1sigma,as.numeric(labBS_results[[i]][5,3]))
}


#histograms
gobsizes<-gobOUwieDat
gobsizes$fam<-"Gobiidae"
labsizes<-labOUwieDat
labsizes$fam<-"Labridae"
rbind(gobsizes,labsizes)->labgobsizes

ggplot(labgobsizes,aes(x=Max.cm.TL,y=fam)) + 
  geom_density_ridges2(aes(fill=fam),alpha=0.85,scale=1,
                       rel_min_height=1E-5) + 
   scale_fill_manual(values = c(rep("#0BB6EA",1),rep("#F4E539",1)
  )) +
  theme_ridges()
